/**
 *	@file	string_test.cpp
 *	@brief	stringNX̃eXg.
 *	@author	tenk*
 *	@date	2010-??
 */

//#undef _DEBUG

#include <cstddef>
#include <cassert>
#include <assert.h>

#include "unitst.h"

#undef assert
#define assert(x)		UNITST_ASSERT(x)

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <cstdlib>
#include <cstring>
#include <iterator>
#include <algorithm>
#include <vector>
#include <istream>

#undef assert
#define assert(x)		UNITST_ASSERT(x)


#include <string>
#include "../ya_string.h"

#ifdef UNICODE
#define T(a)			L##a
#else
#define T(a)			a
#endif
//#define T(a)			L##a

#if defined _MSC_VER
#define TEST_OUT_OF_RANGE(a)		UNITST_ASSERT_THROW(a, std::out_of_range)
#else
#define TEST_OUT_OF_RANGE(a)
#endif

#if 0 //_MSC_VER < 1400
#define TEST_OUT_OF_RANGE_2(a)		UNITST_ASSERT_THROW(a, std::out_of_range)
#define TEST_OUT_OF_RANGE_E(a)		UNITST_ASSERT_NO_THROW(a)
#else
#define TEST_OUT_OF_RANGE_2(a)
#define TEST_OUT_OF_RANGE_E(a)
#endif

#ifdef __BORLANDC__
#define S(s)			STRING(s)
#else
#define S(s)			s
#endif


template<class STRING>
class String_Test {
public:
	void test() {
		test_constructor();
		test_compare();
		test_etc();
		test_assign();
		test_append();
		test_join();
		test_erase();
		test_insert();
		test_replace();
		test_find();
		test_rfind();
		test_find_first_of();
		test_find_last_of();
		test_find_first_not_of();
		test_find_last_not_of();
		test_copy();
		test_swap();
		test_substr();
	}


private:
	typename STRING::iterator ind2ite(STRING& str, std::size_t no) const {
		typename STRING::iterator it(str.begin());
		std::advance(it, no);
		return it;
	}

	/// RXgN^, empty,size,capacity,max_size,length gp
	void test_constructor() {
		// ftHgERXgN^
		STRING	str0;
		UNITST_CHECK (str0.empty());
		UNITST_CHECK (str0.size() == 0);
		UNITST_CHECK (str0.capacity() >= 0);
		UNITST_CHECK (str0.max_size() >= str0.size());

		const STRING str1(T("0123456789"));
		//STRING	str1(10);
		UNITST_CHECK (str1.empty() == false);
		UNITST_CHECK (str1.size()	== 10);
		UNITST_CHECK (str1.length() == 10);
		UNITST_CHECK (str1.capacity() >= 10);
		UNITST_CHECK (str1.max_size() >= str1.size());

		STRING	str2(10, T('@'));
		UNITST_CHECK (str2.empty() == false);
		UNITST_CHECK (str2.size() == 10);
		UNITST_CHECK (str1.length() == 10);
		UNITST_CHECK (str2.capacity() >= 10);
		UNITST_CHECK ( std::memcmp(&str2[0], T("@@@@@@@@@@"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str2.c_str(), T("@@@@@@@@@@"), 11) == 0 );
		UNITST_CHECK (str2.max_size() >= str2.size());

		STRING	str3(str1);
		UNITST_CHECK (str3.empty() == false);
		UNITST_CHECK (str3.size() == 10);
		UNITST_CHECK (str3.capacity() >= 10);
		UNITST_CHECK ( std::memcmp(str3.data() , T("0123456789"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str3.c_str(), T("0123456789"), 11) == 0 );
		UNITST_CHECK (str3.max_size() >= str3.size());
		UNITST_CHECK ( std::memcmp(str3.data() , T("0123456789"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str3.c_str(), T("0123456789"), 11) == 0 );

		TEST_OUT_OF_RANGE( STRING	str4a(str1,100) );

		STRING	str4(str1, 2);
		UNITST_CHECK (str4.empty() == false);
		UNITST_CHECK (str4.size() == 8);
		UNITST_CHECK (str4.capacity() >= 8);
		UNITST_CHECK ( std::memcmp(str4.data() , T("23456789"), 8) == 0 );
		UNITST_CHECK ( std::memcmp(str4.c_str(), T("23456789"), 9) == 0 );
		UNITST_CHECK (str4.max_size() >= str4.size());

		TEST_OUT_OF_RANGE( STRING	str5a(str1, 100, 5) );

		STRING	str5(str1, 3, 5);
		UNITST_CHECK (str5.empty() == false);
		UNITST_CHECK (str5.size() == 5);
		UNITST_CHECK (str5.capacity() >= 5);
		UNITST_CHECK ( std::memcmp(str5.data() , T("34567"), 5) == 0 );
		UNITST_CHECK ( std::memcmp(str5.c_str(), T("34567"), 6) == 0 );
		UNITST_CHECK (str5.max_size() >= str5.size());

		STRING	str6(T("0123456789"), 6);
		UNITST_CHECK (str6.empty() == false);
		UNITST_CHECK (str6.size() == 6);
		UNITST_CHECK (str6.capacity() >= 6);
		UNITST_CHECK ( std::memcmp(str6.data(),  T("012345"), 6) == 0 );
		UNITST_CHECK ( std::memcmp(str6.c_str(), T("012345"), 7) == 0 );
		UNITST_CHECK (str6.max_size() >= str6.size());

		STRING	str7(str1.begin(), str1.end());
		UNITST_CHECK (str7.empty() == false);
		UNITST_CHECK (str7.size() == 10);
		UNITST_CHECK (str7.capacity() >= 10);
		UNITST_CHECK ( std::memcmp(str7.data(),  T("0123456789"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str7.c_str(), T("0123456789"), 11) == 0 );
		UNITST_CHECK (str7.max_size() >= str7.size());

		STRING	str8(T("abcd\0efghi"), 10);
		UNITST_CHECK (str8.empty() == false);
		std::size_t l = str8.size();
		UNITST_CHECK (l == 10);
		UNITST_CHECK (str8.capacity() >= 10);
		UNITST_CHECK ( std::memcmp(str8.data(),  T("abcd\0efghi"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str8.c_str(), T("abcd"), 5) == 0 );
		UNITST_CHECK (str8.max_size() >= str8.size());

		STRING	str9(str1.end(), str1.end());
		UNITST_CHECK (str9.empty() != false);
		UNITST_CHECK (str9.size() == 0);
		UNITST_CHECK (str9.max_size() >= str9.size());
	}

	/// r
	void test_compare()
	{
		const STRING	str0;
		const STRING	str1(T("0123456789"));
		const STRING	str5(str1, 3, 5);
		const STRING	str6(T("abcdefghij"));
		const STRING	str7(T("abcdefghij"), 7);
		const STRING	str8(str1);

		UNITST_CHECK (str1 != str0);
		UNITST_CHECK ((str1 == str0) == 0);
		UNITST_CHECK (str0 <= str1);
		UNITST_CHECK (str0 <  str1);
		UNITST_CHECK (str1 >= str0);
		UNITST_CHECK (str1 >  str0);

		UNITST_CHECK (str8 != str7);
		UNITST_CHECK ((str8 == str7) == 0);
		UNITST_CHECK (str8 <= str7);
		UNITST_CHECK (str8 <  str7);
		UNITST_CHECK (str7 >= str8);
		UNITST_CHECK (str7 >  str8);

		UNITST_CHECK (str6 != str7);
		UNITST_CHECK ((str6 == str7) == 0);
		UNITST_CHECK (str6 >= str7);
		UNITST_CHECK (str6 >  str7);
		UNITST_CHECK (str7 <= str6);
		UNITST_CHECK (str7 <  str6);

		UNITST_CHECK (str8 == str1);
		UNITST_CHECK ((str8 != str1) == 0);
		UNITST_CHECK ((str8 <= str1) != 0);
		UNITST_CHECK ((str8 <  str1) == 0);
		UNITST_CHECK ((str8 >= str1) != 0);
		UNITST_CHECK ((str8 >  str1) == 0);

		UNITST_CHECK ((str0 == T("")) != 0);
		UNITST_CHECK ((str0 != T("")) == 0);
		UNITST_CHECK ((str0 <= T("")) != 0);
		UNITST_CHECK ((str0 <  T("")) == 0);
		UNITST_CHECK ((str0 >= T("")) != 0);
		UNITST_CHECK ((str0 >  T("")) == 0);

		UNITST_CHECK ((str1 == T("")) == 0);
		UNITST_CHECK ((str1 != T("")) != 0);
		UNITST_CHECK ((str1 <= T("")) == 0);
		UNITST_CHECK ((str1 <  T("")) == 0);
		UNITST_CHECK ((str1 >= T("")) != 0);
		UNITST_CHECK ((str1 >  T("")) != 0);

		UNITST_CHECK ((str8 == T("0123456789")) != 0);
		UNITST_CHECK ((str8 != T("0123456789")) == 0);
		UNITST_CHECK ((str8 <= T("0123456789")) != 0);
		UNITST_CHECK ((str8 <  T("0123456789")) == 0);
		UNITST_CHECK ((str8 >= T("0123456789")) != 0);
		UNITST_CHECK ((str8 >  T("0123456789")) == 0);

		UNITST_CHECK ((T("") == str0) != 0);
		UNITST_CHECK ((T("") != str0) == 0);
		UNITST_CHECK ((T("") <= str0) != 0);
		UNITST_CHECK ((T("") <	str0) == 0);
		UNITST_CHECK ((T("") >= str0) != 0);
		UNITST_CHECK ((T("") >	str0) == 0);

		UNITST_CHECK ((T("") == str1) == 0);
		UNITST_CHECK ((T("") != str1) != 0);
		UNITST_CHECK ((T("") <= str1) != 0);
		UNITST_CHECK ((T("") <	str1) != 0);
		UNITST_CHECK ((T("") >= str1) == 0);
		UNITST_CHECK ((T("") >	str1) == 0);

		UNITST_CHECK (T("0123456789") == str1);
		UNITST_CHECK ((T("0123456789") != str1) == 0);
		UNITST_CHECK ((T("0123456789") <= str1) != 0);
		UNITST_CHECK ((T("0123456789") <  str1) == 0);
		UNITST_CHECK ((T("0123456789") >= str1) != 0);
		UNITST_CHECK ((T("0123456789") >  str1) == 0);

		UNITST_CHECK (str8.compare(str1) == 0);
		UNITST_CHECK (str8.compare(str7) < 0);
		UNITST_CHECK (str7.compare(str8) > 0);
		UNITST_CHECK (str6.compare(str7) > 0);
		UNITST_CHECK (str7.compare(str6) < 0);
		UNITST_CHECK (str8.compare(T("0123456789")) == 0);
		UNITST_CHECK (str8.compare(T("0123456789a")) < 0);
		UNITST_CHECK (str8.compare(T("012345678")) > 0);
		//x UNITST_CHECK (str4.compare(str0,2) == 0);
		//UNITST_CHECK (str5.compare(str0,3,5) == 0);
		UNITST_CHECK (str1.compare(3,5,str5) == 0);
		UNITST_CHECK (str1.compare(3,4,str5) <	0);
		UNITST_CHECK (str1.compare(3,6,str5) >	0);
		//x UNITST_CHECK (str1.compare(3,5,str5,0) == 0);
		UNITST_CHECK (str1.compare(3,5,str5,0,5) == 0);
		UNITST_CHECK (str1.compare(3,5,str5,0,4) >	0);
		UNITST_CHECK (str1.compare(3,4,str5,0,5) <	0);

		UNITST_CHECK (str1.compare(3,5,T("3456789"),5) == 0);
		UNITST_CHECK (str1.compare(3,5,T("3456789"),6) <  0);
		UNITST_CHECK (str1.compare(3,5,T("3456789"),12) <  0);
		UNITST_CHECK (str1.compare(3,5,T("3456789"),4) >  0);
		UNITST_CHECK (str1.compare(2,5,T("3456789"),5) <  0);
		UNITST_CHECK (str1.compare(2,5,T("3456789"),12) <  0);

		UNITST_CHECK (str1.compare(8,8,str8, 8,8) == 0);
		UNITST_CHECK (str1.compare(8,8,str8, 8,2) == 0);
		UNITST_CHECK (str1.compare(8,8,str8, 8,1) >  0);
		UNITST_CHECK (str1.compare(8,8,str8, 7,5) >  0);
		UNITST_CHECK (str1.compare(8,8,str8, 9,2) <  0);

		UNITST_CHECK (str1.compare(8,8,T("89")) == 0);
		UNITST_CHECK (str1.compare(8,8,T("89"),2) == 0);
		UNITST_CHECK (str1.compare(8,8,T("89abcd")) < 0);
		UNITST_CHECK (str1.compare(8,8,T("89abcd"),6) < 0);
		UNITST_CHECK (str1.compare(8,8,T("789abcd")) > 0);
		UNITST_CHECK (str1.compare(8,8,T("789abcd"),7) > 0);
		UNITST_CHECK (str1.compare(8,8,T("89abcd"), 2) == 0);
		UNITST_CHECK (str1.compare(8,8,T("89"), 3) != 0);
		//x UNITST_CHECK (str1.compare(8,8,T("89"), 5) == 0);	// T('\0')I[ƂĂ͈Ȃ͗l...

		UNITST_CHECK (str1.compare(str0) > 0);
		UNITST_CHECK (str0.compare(str7) < 0);
		UNITST_CHECK (str0.compare(T("")) == 0);
		UNITST_CHECK (str0.compare(T("012345")) < 0);

	  #if 1 	// ItZbgʒusȏꍇ͗O𓊂ق悢?
		TEST_OUT_OF_RANGE(UNITST_CHECK(str0.compare(3,5,str5) < 0));
		TEST_OUT_OF_RANGE(UNITST_CHECK(str0.compare(3,5,str5,0,5) < 0));
		TEST_OUT_OF_RANGE(UNITST_CHECK(str1.compare(3,5,str0,1,5) > 0));
		TEST_OUT_OF_RANGE(UNITST_CHECK(str0.compare(3,5,str0,1,5) == 0));
		TEST_OUT_OF_RANGE(UNITST_CHECK(str1.compare(0,5,str0,1,5) > 0));
		TEST_OUT_OF_RANGE(UNITST_CHECK(str0.compare(0,5,str0,1,5) == 0));

		TEST_OUT_OF_RANGE(UNITST_CHECK(str0.compare(3,5,T("3456789"),5) < 0));
		TEST_OUT_OF_RANGE(UNITST_CHECK(str0.compare(3,5,T(""),5) == 0));
	  #endif
	}


	/// [], at, begin, end, rbegin, rend, swap gp
	void test_etc()
	{
		// ftHgERXgN^
		STRING	str0;
		UNITST_CHECK (str0.empty());
		UNITST_CHECK (str0.size() == 0);
		UNITST_CHECK (str0.capacity() >= 0);
		UNITST_CHECK (str0.max_size() >= str0.size());

		// 		U[u
		str0.reserve(100);
		UNITST_CHECK (str0.empty());
		UNITST_CHECK (str0.length() == 0);
		UNITST_CHECK (str0.capacity() >= 100);
		UNITST_CHECK (str0.max_size() >= str0.size());

		// TCY
		str0.resize(10, T(' '));
		UNITST_CHECK (str0.empty() == false);
		UNITST_CHECK (str0.size() == 10);
		UNITST_CHECK (str0.capacity() >= 100);
		UNITST_CHECK ( std::memcmp(&str0[0], T("          "), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str0.data() , T("          "), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str0.c_str(), T("          "), 11) == 0 );
		UNITST_CHECK (str0.max_size() >= str0.size());

		//		at
	  #ifndef UNUSE_THROW
		try {
			for (int i = 0; i < 11; ++i)
				str0.at(i) = char(T('0')+i);
		} catch (...) {
			;
		}
		UNITST_CHECK ( std::memcmp(str0.data() , T("0123456789"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str0.c_str(), T("0123456789"), 11) == 0 );
	  #endif

		const STRING str1(T("0123456789"));
		//STRING	str1(10);
		UNITST_CHECK (str1.empty() == false);
		UNITST_CHECK (str1.size()	== 10);
		UNITST_CHECK (str1.length() == 10);
		UNITST_CHECK (str1.capacity() >= 10);
		UNITST_CHECK (str1.max_size() >= str1.size());

		STRING	str1b = str1;
		UNITST_CHECK ( std::memcmp(str1b.data() , T("0123456789"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str1b.c_str(), T("0123456789"), 11) == 0 );

	  #ifndef UNUSE_THROW
		//		[]	const at()
		try {
			for (int i = 0; i < 11; ++i) {
				char c = (str1.at(9-i));
				str0[i] = c;
			}
		} catch (...) {
			;
		}
		UNITST_CHECK ( std::memcmp(str0.data() , T("9876543210"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str0.c_str(), T("9876543210"), 11) == 0 );
	  #endif

		//		const []
		for (int i = 0; i < 10; ++i)
			str0[i] = str1[i];
		UNITST_CHECK ( std::memcmp(str0.data() , T("0123456789"), 10) == 0 );
		UNITST_CHECK ( std::memcmp(str0.c_str(), T("0123456789"), 11) == 0 );

		// begin,end
		STRING	str2(str0.begin(), str0.end());
		UNITST_CHECK ( str2 == T("0123456789") );

	  #ifndef YA_STRING_NO_MEMBER_TEMPLATES	// o[ev[gT|[g̏ꍇ.
		// rbegin,rend
		STRING	str3(str0.rbegin(), str0.rend());
		UNITST_CHECK ( str3 == T("9876543210") );
	  #endif

		// const begin, const end
		STRING	str4(str1.begin(), str1.end());
		UNITST_CHECK ( str4 == T("0123456789") );

	  #ifndef YA_STRING_NO_MEMBER_TEMPLATES	// o[ev[gT|[g̏ꍇ.
		// const rbegin, const rend
		STRING	str5(str1.rbegin(), str1.rend());
		UNITST_CHECK ( str5 == T("9876543210") );
	  #else
		STRING	str5("9876543210");
	  #endif

		str4.swap(str5);
		UNITST_CHECK (str4 == T("9876543210"));
		UNITST_CHECK (str5 == T("0123456789"));

		std::swap( str4, str5 );
		UNITST_CHECK (str4 == T("0123456789"));
		UNITST_CHECK (str5 == T("9876543210"));
	}


	/// copy
	void test_copy()
	{
		const STRING	str0(T("0123456789"));
		char buf[100];
		str0.copy(buf, 4);			UNITST_CHECK(std::memcmp(buf, T("0123"), 4) == 0);
		str0.copy(buf, 10);			UNITST_CHECK(std::memcmp(buf, T("0123456789"), 10) == 0);
		str0.copy(buf, 32);			UNITST_CHECK(std::memcmp(buf, T("0123456789"), 10) == 0);
		str0.copy(buf, 4, 1);		UNITST_CHECK(std::memcmp(buf, T("1234"), 4) == 0);
		str0.copy(buf,9, 1);		UNITST_CHECK(std::memcmp(buf, T("123456789"), 9) == 0);
		str0.copy(buf, 32, 1);		UNITST_CHECK(std::memcmp(buf, T("123456789"), 9) == 0);

		TEST_OUT_OF_RANGE( str0.copy(buf, 4, 100) );
		UNITST_CHECK(std::memcmp(buf, T("123456789"), 9) == 0);

		TEST_OUT_OF_RANGE_2( str0.copy(NULL, 4, 100) );
		TEST_OUT_OF_RANGE_2( str0.copy(NULL, 33, 32) );
		UNITST_ASSERT_NO_THROW( str0.copy(buf, 0, 0) );
	}

	// swap
	void test_swap()
	{
		STRING str2 = T("abcdefghijklemopqrstuvwxyz");
		STRING str3 = T("0123456789ABCDEF");
		str2.swap(str3);
		UNITST_CHECK (str2 == T("0123456789ABCDEF"));
		UNITST_CHECK (str3 == T("abcdefghijklemopqrstuvwxyz"));

		using std::swap;
		swap( str2, str3 );

		UNITST_CHECK (str2 == T("abcdefghijklemopqrstuvwxyz"));
		UNITST_CHECK (str3 == T("0123456789ABCDEF"));
	}

	void test_substr()
	{
		const STRING str0(T("abcdefghijklmnopqrstuvwxyz"));
		STRING str1;
		str1 = str0.substr();			UNITST_CHECK (str1 == T("abcdefghijklmnopqrstuvwxyz"));
		str1 = str0.substr(0, 5);		UNITST_CHECK (str1 == T("abcde"));
		str1 = str0.substr(1,5);		UNITST_CHECK (str1 == T("bcdef"));
		str1 = str0.substr(5);			UNITST_CHECK (str1 == T("fghijklmnopqrstuvwxyz"));

		str1 = str0.substr(25);			UNITST_CHECK (str1 == T("z"));

		str1 = str0.substr(25, 10);		UNITST_CHECK (str1 == T("z"));

		str1 = str0.substr(26);			UNITST_CHECK (str1 == T(""));

		TEST_OUT_OF_RANGE( str1.substr(27) );
		TEST_OUT_OF_RANGE( str1.substr(27, 10) );
	}


	/// ( =, assign )
	void test_assign()
	{
		const STRING	str0(T("0123456789"));

		STRING str1;
		UNITST_ASSERT_NO_THROW(str1 = str0);
		UNITST_CHECK( str1 == str0 );
		UNITST_CHECK( str1.size() == 10 && std::memcmp(str1.c_str(), str0.data(), 10) == 0);

		str1 = str1;
		UNITST_CHECK( str1 == str0 );
		UNITST_CHECK( str1.size() == 10 && std::memcmp(str1.c_str(), str0.data(), 10) == 0);

		str1 = T("abcdefg");
		UNITST_CHECK( str1 == T("abcdefg") );

		str1 = T('z');
		UNITST_CHECK( str1 == T("z") );

		UNITST_ASSERT_NO_THROW(str1.assign(10, T('@')));
		UNITST_CHECK( str1 == T("@@@@@@@@@@") );

		UNITST_ASSERT_NO_THROW(str1.assign(T("0123456789")));
		UNITST_CHECK( str1 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str1.assign(T("0123456789"), 5));
		UNITST_CHECK( str1 == T("01234") );

		UNITST_ASSERT_NO_THROW(str1.assign(str0));
		UNITST_CHECK( str1 == T("0123456789") );

		TEST_OUT_OF_RANGE( str1.assign(str0, 100, 5) );

		UNITST_ASSERT_NO_THROW(str1.assign(str0, 3,5));
		UNITST_CHECK( str1 == T("34567") );

	  #ifndef YA_STRING_NO_MEMBER_TEMPLATES	// o[ev[gT|[g̏ꍇ.
		UNITST_ASSERT_NO_THROW(str1.assign(str0.rbegin(), str0.rend()));
		UNITST_CHECK( str1 == T("9876543210") );
	  #endif

		UNITST_ASSERT_NO_THROW(str1.assign(str0.end(), str0.end()));
		UNITST_CHECK( str1 == T("") );

	  #if 0
		str1.assign(str0, 4);
		UNITST_CHECK( str1 == T("456789") );
	  #endif

	}

	/// ǉ
	void test_append()
	{
		const STRING	str0(T("0123456789"));

		STRING str1;
		str1 += T("");
		UNITST_CHECK( str1.empty() );
		str1 += str0;
		UNITST_CHECK( str1 == str0 );
		UNITST_CHECK( str1.size() == 10 && std::memcmp(str1.c_str(), str0.data(), 10) == 0);

		UNITST_ASSERT_NO_THROW(str1 += T("abcdefg"));
		UNITST_CHECK( str1 == T("0123456789abcdefg") );

		UNITST_ASSERT_NO_THROW(str1 += T('_'));
		UNITST_CHECK( str1 == T("0123456789abcdefg_") );

		UNITST_ASSERT_NO_THROW(str1.append(T("testtest")));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest") );

		UNITST_ASSERT_NO_THROW(str1.append(T("0123456789"), 5));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234") );

		UNITST_ASSERT_NO_THROW(str1.append(10, T('@')));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234@@@@@@@@@@") );

		UNITST_ASSERT_NO_THROW(str1.append(str0));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234@@@@@@@@@@0123456789") );

		TEST_OUT_OF_RANGE( str1.append(str0, 133, 5) );

		UNITST_ASSERT_NO_THROW(str1.append(str0, 3,5));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234@@@@@@@@@@012345678934567") );

	  #ifndef YA_STRING_NO_MEMBER_TEMPLATES	// o[ev[gT|[g̏ꍇ.
		UNITST_ASSERT_NO_THROW(str1.append(str0.rbegin(), str0.rend()));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234@@@@@@@@@@0123456789345679876543210") );

		UNITST_ASSERT_NO_THROW(str1.append(str0.rend(), str0.rend()));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234@@@@@@@@@@0123456789345679876543210") );
	  #endif

	  #if 0
		UNITST_ASSERT_NO_THROW(str1.append(str0, 4));
		UNITST_CHECK( str1 == T("0123456789abcdefg_testtest01234@@@@@@@@@@0123456789345679876543210456789") );
	  #endif
	}

	void test_join()
	{
		const STRING	str0;
		const STRING	str1 = T("0123456789");
		const STRING	str2 = T("abcde");
		STRING			str3;
		UNITST_ASSERT_NO_THROW(str3 = str0 + str1);
		UNITST_CHECK( str3 == T("0123456789") );
		UNITST_ASSERT_NO_THROW(str3 = str1 + str0);
		UNITST_CHECK( str3 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str3 = str2 + str1);
		UNITST_CHECK( str3 == T("abcde0123456789") );
		UNITST_ASSERT_NO_THROW(str3 = str1 + str2);
		UNITST_CHECK( str3 == T("0123456789abcde") );

		UNITST_ASSERT_NO_THROW(str3 = T("") + str0);
		UNITST_CHECK( str3.empty() );
		UNITST_ASSERT_NO_THROW(str3 = str0 + T(""));
		UNITST_CHECK( str3.empty() );

		UNITST_ASSERT_NO_THROW(str3 = T("") + str1);
		UNITST_CHECK( str3 == T("0123456789") );
		UNITST_ASSERT_NO_THROW(str3 = str1 + T(""));
		UNITST_CHECK( str3 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str3 = T("@") + str1);
		UNITST_CHECK( str3 == T("@0123456789") );
		UNITST_ASSERT_NO_THROW(str3 = str1 + T("@"));
		UNITST_CHECK( str3 == T("0123456789@") );

		UNITST_ASSERT_NO_THROW(str3 = T("string") + str1);
		UNITST_CHECK( str3 == T("string0123456789") );
		UNITST_ASSERT_NO_THROW(str3 = str1 + T("string"));
		UNITST_CHECK( str3 == T("0123456789string") );

		UNITST_ASSERT_NO_THROW(str3 = T('@') + str0);
		UNITST_CHECK( str3 == T("@") );
		UNITST_ASSERT_NO_THROW(str3 = str0 + T('@'));
		UNITST_CHECK( str3 == T("@") );

		UNITST_ASSERT_NO_THROW(str3 = T('@') + str1);
		UNITST_CHECK( str3 == T("@0123456789") );
		UNITST_ASSERT_NO_THROW(str3 = str1 + T('@'));
		UNITST_CHECK( str3 == T("0123456789@") );
	}

	/// 폜
	void test_erase()
	{
		STRING	str0 = T("0123456789");
		UNITST_ASSERT_NO_THROW(str0.erase(9));
		UNITST_CHECK( str0 == T("012345678") );
		UNITST_ASSERT_NO_THROW(str0.erase(8,1));
		UNITST_CHECK( str0 == T("01234567") );
		UNITST_ASSERT_NO_THROW(str0.erase(6));
		UNITST_CHECK( str0 == T("012345") );
		UNITST_ASSERT_NO_THROW(str0.erase(4,3));
		UNITST_CHECK( str0 == T("0123") );
		UNITST_ASSERT_NO_THROW(str0.erase(1,2));
		UNITST_CHECK( str0 == T("03") );
		UNITST_ASSERT_NO_THROW(str0.erase(0,1));
		UNITST_CHECK( str0 == T("3") );
		UNITST_ASSERT_NO_THROW(str0.erase(size_t(0)));
		UNITST_CHECK( str0 == T("") );

		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));

		TEST_OUT_OF_RANGE_E( str0.erase(str0.end()+1) );
		UNITST_EQ( str0.size(), 10 );
		UNITST_EQ_STRING( str0, S( T("0123456789")) );
		UNITST_ASSERT_NO_THROW(str0.erase(str0.end()));
		UNITST_EQ( str0.size(), 10 );
		UNITST_EQ_STRING( str0, S( T("0123456789")) );

		UNITST_ASSERT_NO_THROW(str0.erase(ind2ite(str0,4), ind2ite(str0,7)));
		UNITST_EQ_STRING( str0, S( T("0123789")) );

		UNITST_ASSERT_NO_THROW(str0.erase(ind2ite(str0,3)));
		UNITST_EQ_STRING( str0, S( T("012789")) );

		UNITST_ASSERT_NO_THROW(str0.erase(str0.begin(), str0.end()));
		UNITST_EQ_STRING( str0, S( T("")) );

	  #if 0 //_MSC_VER < 1400
		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		UNITST_ASSERT_NO_THROW(str0.erase( str0.begin(), str0.end()+100));
		UNITST_CHECK( str0 == T("") );

		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		TEST_OUT_OF_RANGE( str0.erase( str0.begin()-10, str0.end() ) );
		UNITST_CHECK( str0 == T("0123456789") );

		STRING str1(T("abcdefg"));
		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		TEST_OUT_OF_RANGE( str0.erase( str1.begin(), str1.end() ) );
		UNITST_CHECK( str0 == T("0123456789") );
	  #endif
	}

	/// }
	void test_insert()
	{
		STRING	str0;

		TEST_OUT_OF_RANGE( str0.insert(1, T("236")) );
		UNITST_ASSERT_NO_THROW(str0.insert(0, T("236")));
		UNITST_CHECK( str0 == T("236") );

		TEST_OUT_OF_RANGE( str0.insert(6, T("01"),1) );
		UNITST_ASSERT_NO_THROW(str0.insert(0, T("01"),1));
		UNITST_CHECK( str0 == T("0236") );

		TEST_OUT_OF_RANGE( str0.insert(std::size_t(-1), 1, T('1')) );
		UNITST_ASSERT_NO_THROW(str0.insert(1, 1, T('1')));
		UNITST_CHECK( str0 == T("01236") );

		TEST_OUT_OF_RANGE( str0.insert(40, T("45")) );
		UNITST_ASSERT_NO_THROW(str0.insert(4, T("45")));
		UNITST_CHECK( str0 == T("0123456") );

		UNITST_ASSERT_NO_THROW(str0.insert(7, T("789")));
		UNITST_CHECK( str0 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str0.insert(10, T("@#%$!"),5));
		UNITST_CHECK( str0 == T("0123456789@#%$!"));

		STRING	str1;

		TEST_OUT_OF_RANGE( str1.insert(100, str0, 10, 3) );
		UNITST_ASSERT_NO_THROW(str1.insert(0, str0, 10, 3));
		UNITST_CHECK( str1 == T("@#%") );

		TEST_OUT_OF_RANGE( str1.insert(100U, str0, 13U, STRING::npos) );
		UNITST_ASSERT_NO_THROW(str1.insert(3U, str0, 13U, STRING::npos));
		UNITST_CHECK( str1 == T("@#%$!") );

		UNITST_ASSERT_NO_THROW(str1.insert(5, str0, 0, 10));
		UNITST_CHECK( str1 == T("@#%$!0123456789") );

		TEST_OUT_OF_RANGE( str1.insert(str1.size()+1, str0) );
		UNITST_ASSERT_NO_THROW(str1.insert(str1.size(), str0));
		UNITST_CHECK( str1 == T("@#%$!01234567890123456789@#%$!") );

		TEST_OUT_OF_RANGE_2( str1.insert(str0.begin(), T('-')) );
		UNITST_ASSERT_NO_THROW(str1.insert(ind2ite(str1,5), T('-')));
		UNITST_CHECK( str1 == T("@#%$!-01234567890123456789@#%$!") );

		TEST_OUT_OF_RANGE_2( str1.insert(str0.begin(), 4, T('+')) );
		UNITST_ASSERT_NO_THROW(str1.insert(ind2ite(str1,6), 4, T('+')));
		UNITST_CHECK( str1 == T("@#%$!-++++01234567890123456789@#%$!") );

	  #ifndef YA_STRING_NO_MEMBER_TEMPLATES	// o[ev[gT|[g̏ꍇ.
		TEST_OUT_OF_RANGE_2( str1.insert(ind2ite(str0,5), str0.rbegin(), str0.rend()) );
		UNITST_ASSERT_NO_THROW(str1.insert(ind2ite(str1,5), str0.rbegin(), str0.rend()));
		UNITST_CHECK( str1 == T("@#%$!!$%#@9876543210-++++01234567890123456789@#%$!") );
	  #endif
	}


	// u
	void test_replace()
	{
		// }
		STRING	str0;

		TEST_OUT_OF_RANGE( str0.replace(1, 5, T("236")) );
		UNITST_ASSERT_NO_THROW(str0.replace(0,1, T("236")));
		UNITST_CHECK( str0 == T("236") );

		TEST_OUT_OF_RANGE( str0.replace(6,1, T("01"),1) );
		UNITST_ASSERT_NO_THROW(str0.replace(size_t(0),size_t(0), T("01"),1));
		UNITST_CHECK( str0 == T("0236") );

		TEST_OUT_OF_RANGE( str0.replace(unsigned(-1),1, 1, T('1')) );
		UNITST_ASSERT_NO_THROW(str0.replace(1,0, 1, T('1')));
		UNITST_CHECK( str0 == T("01236") );

		TEST_OUT_OF_RANGE( str0.replace(40,0, T("45")) );
		UNITST_ASSERT_NO_THROW(str0.replace(4,0, T("45")));
		UNITST_CHECK( str0 == T("0123456") );

		UNITST_ASSERT_NO_THROW(str0.replace(7,0, T("789")));
		UNITST_CHECK( str0 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str0.replace(10,0, T("@#%$!"),5));
		UNITST_CHECK( str0 == T("0123456789@#%$!"));

		STRING	str1;

		TEST_OUT_OF_RANGE( str1.replace(100U,0U, str0, 10U, 3U) );
		UNITST_ASSERT_NO_THROW(str1.replace(0U,0U, str0, 10U, 3U));
		UNITST_CHECK( str1 == T("@#%") );

		TEST_OUT_OF_RANGE( str1.replace(100U,0U, str0, 13U, STRING::npos) );
		UNITST_ASSERT_NO_THROW(str1.replace(3,0, str0, 13, STRING::npos));
		UNITST_CHECK( str1 == T("@#%$!") );

		UNITST_ASSERT_NO_THROW(str1.replace(5,0, str0, 0, 10));
		UNITST_CHECK( str1 == T("@#%$!0123456789") );

		TEST_OUT_OF_RANGE( str1.replace(str1.size()+1,0, str0) );
		UNITST_ASSERT_NO_THROW(str1.replace(str1.size(),0, str0));
		UNITST_CHECK( str1 == T("@#%$!01234567890123456789@#%$!") );

		TEST_OUT_OF_RANGE_2( str1.replace(ind2ite(str0,0),ind2ite(str0,1), 1, T('-')) );
		UNITST_ASSERT_NO_THROW(str1.replace(ind2ite(str1,5),ind2ite(str1,5), 1,T('-')));
		UNITST_CHECK( str1 == T("@#%$!-01234567890123456789@#%$!") );

		TEST_OUT_OF_RANGE_2( str1.replace(ind2ite(str0,0),ind2ite(str0,0), 4, T('+')) );
		UNITST_ASSERT_NO_THROW(str1.replace(ind2ite(str1,6),ind2ite(str1,6), 4, T('+')));
		UNITST_CHECK( str1 == T("@#%$!-++++01234567890123456789@#%$!") );

	  #ifndef YA_STRING_NO_MEMBER_TEMPLATES	// o[ev[gT|[g̏ꍇ.
		TEST_OUT_OF_RANGE_2( str1.replace(ind2ite(str0,5),ind2ite(str0,5), str0.rbegin(), str0.rend()) );
		UNITST_ASSERT_NO_THROW(str1.replace(ind2ite(str1,5),ind2ite(str1,5), str0.rbegin(), str0.rend()));
		UNITST_CHECK( str1 == T("@#%$!!$%#@9876543210-++++01234567890123456789@#%$!") );
	  #endif

		// 폜
		STRING str2;
		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		UNITST_ASSERT_NO_THROW(str0.replace(9,str0.npos, T("")));
		UNITST_CHECK( str0 == T("012345678") );
		UNITST_ASSERT_NO_THROW(str0.replace(8,1, str2));
		UNITST_CHECK( str0 == T("01234567") );
		UNITST_ASSERT_NO_THROW(str0.replace(6,str0.npos, str2, 0, 1));
		UNITST_CHECK( str0 == T("012345") );
		UNITST_ASSERT_NO_THROW(str0.replace(4,3, T("")));
		UNITST_CHECK( str0 == T("0123") );
		UNITST_ASSERT_NO_THROW(str0.replace(1,2, str2));
		UNITST_CHECK( str0 == T("03") );
		UNITST_ASSERT_NO_THROW(str0.replace(0,1, str2, 0, 0));
		UNITST_CHECK( str0 == T("3") );
		UNITST_ASSERT_NO_THROW(str0.replace(0,1, T(""), 0));
		UNITST_CHECK( str0 == T("") );

		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));

		TEST_OUT_OF_RANGE_2( str0.replace(str0.end()+1, str0.end()+1, T("")) );
		UNITST_ASSERT_NO_THROW(str0.replace(str0.end(), str0.end(), T("")));
		UNITST_CHECK( str0 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,4), ind2ite(str0,7), str2));
		UNITST_CHECK( str0 == T("0123789") );

		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,3), ind2ite(str0,4), str2.begin(), str2.end()));
		UNITST_CHECK( str0 == T("012789") );

		UNITST_ASSERT_NO_THROW(str0.replace(str0.begin(), str0.end(), str2));
		UNITST_CHECK( str0 == T("") );

		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		TEST_OUT_OF_RANGE_E(str0.replace( str0.begin(), str0.end()+100, str2));
		//UNITST_CHECK( str0 == T("") );
		//UNITST_CHECK( str0 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		TEST_OUT_OF_RANGE_2( str0.replace( str0.begin()-10, str0.end(), T("") ) );
		TEST_OUT_OF_RANGE_2( str0.replace( str0.begin()-10, str0.end()+10, T("") ) );
		UNITST_CHECK( str0 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str1 = T("abcdefg"));
		UNITST_ASSERT_NO_THROW(str0 = T("0123456789"));
		TEST_OUT_OF_RANGE_2( str0.replace( str1.begin(), str1.end(), T("") ) );
		TEST_OUT_OF_RANGE_2( str0.replace( str1.begin(), str1.end(), str2.begin(), str2.end() ) );
		UNITST_CHECK( str0 == T("0123456789") );

		// u
		UNITST_ASSERT_NO_THROW(str0.replace(str0.begin(), str0.end(), T("")));
		UNITST_CHECK( str0 == T("") );
		UNITST_ASSERT_NO_THROW(str1.replace(str1.begin(), str1.end(), T("ABCDEFGHIJ")));
		UNITST_CHECK( str1 == T("ABCDEFGHIJ") );

		UNITST_ASSERT_NO_THROW(str0.replace(size_t(0U),size_t(0U), T("000222")));
		UNITST_CHECK( str0 == T("000222") );
		UNITST_ASSERT_NO_THROW(str0.replace(1,4, T("1")));
		UNITST_CHECK( str0 == T("012") );
		UNITST_ASSERT_NO_THROW(str0.replace(str0.end(),str0.end(), T("3456"), 4));
		UNITST_CHECK( str0 == T("0123456") );
		UNITST_ASSERT_NO_THROW(str0.replace(5,5, 10, T('-')));
		UNITST_CHECK( str0 == T("01234----------") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,10), ind2ite(str0,12), 5, T('+')));
		UNITST_CHECK( str0 == T("01234-----+++++---") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,8), ind2ite(str0,10), T("89abcdef"), 5));
		UNITST_CHECK( str0 == T("01234---89abc+++++---") );
		UNITST_ASSERT_NO_THROW(str0.replace(0, 5, T("abcdefghij"), 5));
		UNITST_CHECK( str0 == T("abcde---89abc+++++---") );
		UNITST_ASSERT_NO_THROW(str0.replace(0, 5, T("0123456789")));
		UNITST_CHECK( str0 == T("0123456789---89abc+++++---") );
		UNITST_ASSERT_NO_THROW(str0.replace(0, 15, str1));
		UNITST_CHECK( str0 == T("ABCDEFGHIJabc+++++---") );

		UNITST_ASSERT_NO_THROW(str0.replace(0, str0.max_size(), T("")));
		UNITST_CHECK( str0 == T("") );
		UNITST_ASSERT_NO_THROW(str0.replace(size_t(0U),size_t(0U), T("0123456789")));
		UNITST_CHECK( str0 == T("0123456789") );
		UNITST_ASSERT_NO_THROW(str0.replace(5,1, T("G")));
		UNITST_CHECK( str0 == T("01234G6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(5,1, 1, T('g')));
		UNITST_CHECK( str0 == T("01234g6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(5,1, 5, T('v')));
		UNITST_CHECK( str0 == T("01234vvvvv6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(5,5, T("5#")));
		UNITST_CHECK( str0 == T("012345#6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(6,1, T("abcdefghij"), 6));
		UNITST_CHECK( str0 == T("012345abcdef6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(6,6, str1, 1,3));
		UNITST_CHECK( str0 == T("012345BCD6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(6,3, str1));
		UNITST_CHECK( str0 == T("012345ABCDEFGHIJ6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(6,10, str1, 0,0));
		UNITST_CHECK( str0 == T("0123456789") );
		UNITST_ASSERT_NO_THROW(str0.replace(7,0, str1, 0,10));
		UNITST_CHECK( str0 == T("0123456ABCDEFGHIJ789") );
		UNITST_ASSERT_NO_THROW(str0.replace(7,10, str2, 0,10));
		UNITST_CHECK( str0 == T("0123456789") );

		UNITST_ASSERT_NO_THROW(str0.replace(str0.begin(), str0.end(), T(""), 0U));
		UNITST_CHECK( str0 == T("") );
		UNITST_ASSERT_NO_THROW(str0.replace(str0.begin(), str0.begin(), T("0123456789")));
		UNITST_CHECK( str0 == T("0123456789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,5), ind2ite(str0,6), T("G")));
		UNITST_CHECK( str0 == T("01234G6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,5), ind2ite(str0,6), 1, T('g')));
		UNITST_CHECK( str0 == T("01234g6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,5), ind2ite(str0,6), 5, T('v')));
		UNITST_CHECK( str0 == T("01234vvvvv6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,5), ind2ite(str0,10), T("5#")));
		UNITST_CHECK( str0 == T("012345#6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,6), ind2ite(str0,7), T("abcdefghij"), 6));
		UNITST_CHECK( str0 == T("012345abcdef6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,6), ind2ite(str0,12), ind2ite(str1,1), ind2ite(str1,4)));
		UNITST_CHECK( str0 == T("012345BCD6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,6), ind2ite(str0,9), str1));
		UNITST_CHECK( str0 == T("012345ABCDEFGHIJ6789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,6), ind2ite(str0,16), ind2ite(str1,0), ind2ite(str1,0)));
		UNITST_CHECK( str0 == T("0123456789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,7), ind2ite(str0,7), ind2ite(str1,0), ind2ite(str1,10)));
		UNITST_CHECK( str0 == T("0123456ABCDEFGHIJ789") );
		UNITST_ASSERT_NO_THROW(str0.replace(ind2ite(str0,7), ind2ite(str0,17), str2));
		UNITST_CHECK( str0 == T("0123456789") );

	}

	void test_find()
	{
		std::size_t 	n;

		const STRING	text0;
		n = text0.find(T('0'));				UNITST_EQ( n, text0.npos );
		n = text0.find(T('\0'));			UNITST_EQ( n, text0.npos );
		n = text0.find(T("0"));				UNITST_EQ( n, text0.npos );
		n = text0.find(T('0'), 100);		UNITST_EQ( n, text0.npos );
		n = text0.find(T('\0'),100);		UNITST_EQ( n, text0.npos );
		n = text0.find(T("0"), 100);		UNITST_EQ( n, text0.npos );

	  #if 1
		n = text0.find(T(""));				UNITST_EQ( n, 0 );
		n = text0.find(T("") , 100);		UNITST_EQ( n, text0.npos );
	  #endif

		const STRING text =  T("0123456789"
							   "abcdefghij"
							   "klmnopqrst"
							   "uvwxyz####");

		// 
		n = text.find(T('0'));				UNITST_EQ( n, 0 );
		n = text.find(T('7'));				UNITST_EQ( n, 7 );
		n = text.find(T("0"));				UNITST_EQ( n, 0 );
		n = text.find(T("89"));				UNITST_EQ( n, 8 );
		n = text.find(T("klmno"));			UNITST_EQ( n, 20 );
		n = text.find(T("end"));			UNITST_EQ( n, text.npos );
		n = text.find(T('\0'));				UNITST_EQ( n, text.npos );
		n = text.find(T(""));				UNITST_EQ( n, 0 );
		//n = text.find((char*)0);			UNITST_EQ( n, 0 );

		n = text.find(T('0'), 1);			UNITST_EQ( n, text.npos );
		n = text.find(T('7'), 1);			UNITST_EQ( n, 7 );
		n = text.find(T("0"), 1);			UNITST_EQ( n, text.npos );
		n = text.find(T("67"), 8);			UNITST_EQ( n, text.npos );
		n = text.find(T("78"), 8);			UNITST_EQ( n, text.npos );
		n = text.find(T("89"), 8);			UNITST_EQ( n, 8 );
		n = text.find(T("klmno"), 20);		UNITST_EQ( n, 20 );
		n = text.find(T("end"), 1);			UNITST_EQ( n, text.npos );
		n = text.find(T('\0'), 8);			UNITST_EQ( n, text.npos );
		n = text.find(T(""), 8);			UNITST_EQ( n, 8 );

		n = text.find(STRING(T("0")));				UNITST_EQ( n, 0 );
		n = text.find(STRING(T("89")));				UNITST_EQ( n, 8 );
		n = text.find(STRING(T("klmno")));			UNITST_EQ( n, 20 );
		n = text.find(STRING(T("end")));			UNITST_EQ( n, text.npos );
		n = text.find(STRING(T("0")), 1);			UNITST_EQ( n, text.npos );
		n = text.find(STRING(T("67")), 8);			UNITST_EQ( n, text.npos );
		n = text.find(STRING(T("78")), 8);			UNITST_EQ( n, text.npos );
		n = text.find(STRING(T("89")), 8);			UNITST_EQ( n, 8 );
		n = text.find(STRING(T("klmno")), 20);		UNITST_EQ( n, 20 );
		n = text.find(STRING(T("klmno")), 21);		UNITST_EQ( n, text.npos );
		n = text.find(STRING(T("end")), 1);			UNITST_EQ( n, text.npos );
		n = text.find(STRING(1, T('\0')), 1);		UNITST_EQ( n, text.npos );
		n = text.find(STRING(T("")), 8);			UNITST_EQ( n, 8 );

		// -----
		STRING text2(text);
		text2 += text;

		n = text2.find(T('0'));				UNITST_EQ( n, 0 );
		n = text2.find(T('7'));				UNITST_EQ( n, 7 );
		n = text2.find(T("0"));				UNITST_EQ( n, 0 );
		n = text2.find(T("89"));			UNITST_EQ( n, 8 );
		n = text2.find(T("end"));			UNITST_EQ( n, text2.npos );

		n = text2.find(T('0'), 1);			UNITST_EQ( n, 40 );
		n = text2.find(T('7'), 1);			UNITST_EQ( n, 7 );
		n = text2.find(T("0"), 1);			UNITST_EQ( n, 40 );
		n = text2.find(T("78"), 8);			UNITST_EQ( n, 47 );
		n = text2.find(T("89"), 8);			UNITST_EQ( n, 8 );
		n = text2.find(T("end"), 1);		UNITST_EQ( n, text2.npos );

		n = text2.find(STRING(T("0")));				UNITST_EQ( n, 0 );
		n = text2.find(STRING(T("89")));			UNITST_EQ( n, 8 );
		n = text2.find(STRING(T("end")));			UNITST_EQ( n, text2.npos );
		n = text2.find(STRING(T("0")), 1);			UNITST_EQ( n, 40 );
		n = text2.find(STRING(T("78")), 8);			UNITST_EQ( n, 47 );
		n = text2.find(STRING(T("89")), 8);			UNITST_EQ( n, 8 );
		n = text2.find(STRING(T("end")), 1);		UNITST_EQ( n, text2.npos );
	}


	void test_rfind()
	{
		STRING	text;
		std::size_t n;

		n = text.rfind(T('0'));				UNITST_EQ( n, text.npos );
		n = text.rfind(T('\0'));			UNITST_EQ( n, text.npos );
		n = text.rfind(T("0"));				UNITST_EQ( n, text.npos );
		n = text.rfind(T('0'), 100);		UNITST_EQ( n, text.npos );
		n = text.rfind(T('\0'),100);		UNITST_EQ( n, text.npos );
		n = text.rfind(T("0"), 100);		UNITST_EQ( n, text.npos );

	  #if 1
		n = text.rfind(T(""));				UNITST_EQ( n, 0 );
		n = text.rfind(T("") , 100);		UNITST_EQ( n, 0 );
	  #endif

		text =	T("0123456789")
				T("abcdefghij")
				T("klmnopqrst")
				T("uvwxyz####");

		n = text.rfind(T('0'));				UNITST_EQ( n, 0 );
		n = text.rfind(T('7'));				UNITST_EQ( n, 7 );
		n = text.rfind(T("0"));				UNITST_EQ( n, 0 );
		n = text.rfind(T("89"));			UNITST_EQ( n, 8 );
		n = text.rfind(T("klmno"));			UNITST_EQ( n, 20 );
		n = text.rfind(T("end"));			UNITST_EQ( n, text.npos );

		n = text.rfind(T('0'), 6);			UNITST_EQ( n, 0 );
		n = text.rfind(T('7'), 6);			UNITST_EQ( n, text.npos );
		n = text.rfind(T("0"), 8);			UNITST_EQ( n, 0 );
		n = text.rfind(T("67"), 7 );		UNITST_EQ( n, 6 );
		n = text.rfind(T("78"), 7 );		UNITST_EQ( n, 7 );
		n = text.rfind(T("89"), 7 );		UNITST_EQ( n, text.npos );
		n = text.rfind(T("klmno"), 30 );	UNITST_EQ( n, 20 );
		n = text.rfind(T("end"), 38 );		UNITST_EQ( n, text.npos );

		n = text.rfind(STRING(T("0")));				UNITST_EQ( n, 0 );
		n = text.rfind(STRING(T("89")));			UNITST_EQ( n, 8 );
		n = text.rfind(STRING(T("klmno")));			UNITST_EQ( n, 20 );
		n = text.rfind(STRING(T("end")));			UNITST_EQ( n, text.npos );
		n = text.rfind(STRING(T("0")), 8);			UNITST_EQ( n, 0 );
		n = text.rfind(STRING(T("67")), 7 );		UNITST_EQ( n, 6 );
		n = text.rfind(STRING(T("78")), 7 );		UNITST_EQ( n, 7 );
		n = text.rfind(STRING(T("89")), 7 );		UNITST_EQ( n, text.npos );
		n = text.rfind(STRING(T("klmno")), 30 );	UNITST_EQ( n, 20 );
		n = text.rfind(STRING(T("end")), 38 );		UNITST_EQ( n, text.npos );

		// -----
		text += STRING(text);

		n = text.rfind(T('0'));				UNITST_EQ( n, 40 );
		n = text.rfind(T('7'));				UNITST_EQ( n, 47 );
		n = text.rfind(T("0"));				UNITST_EQ( n, 40 );
		n = text.rfind(T("89"));			UNITST_EQ( n, 48 );
		n = text.rfind(T("klmno"));			UNITST_EQ( n, 60 );
		n = text.rfind(T("end"));			UNITST_EQ( n, text.npos );

		n = text.rfind(T('0'), 46);			UNITST_EQ( n, 40 );
		n = text.rfind(T('7'), 46);			UNITST_EQ( n, 7 );
		n = text.rfind(T("0"), 48);			UNITST_EQ( n, 40 );
		n = text.rfind(T("67"), 47 );		UNITST_EQ( n, 46 );
		n = text.rfind(T("78"), 47 );		UNITST_EQ( n, 47 );
		n = text.rfind(T("89"), 47 );		UNITST_EQ( n, 8  );
		n = text.rfind(T("klmno"), 30 );	UNITST_EQ( n, 20 );
		n = text.rfind(T("end"), 79 );		UNITST_EQ( n, text.npos );

		n = text.rfind(STRING(T("0")));				UNITST_EQ( n, 40 );
		n = text.rfind(STRING(T("89")));			UNITST_EQ( n, 48 );
		n = text.rfind(STRING(T("klmno")));			UNITST_EQ( n, 60 );
		n = text.rfind(STRING(T("end")));			UNITST_EQ( n, text.npos );
		n = text.rfind(STRING(T("0")), 48);			UNITST_EQ( n, 40 );
		n = text.rfind(STRING(T("67")), 47 );		UNITST_EQ( n, 46 );
		n = text.rfind(STRING(T("78")), 47 );		UNITST_EQ( n, 47 );
		n = text.rfind(STRING(T("89")), 47 );		UNITST_EQ( n, 8  );
		n = text.rfind(STRING(T("klmno")), 30);		UNITST_EQ( n, 20 );
		n = text.rfind(STRING(T("end")), 79 );		UNITST_EQ( n, text.npos );
	}

	void test_find_first_of()
	{
		STRING	text =	T("0123456789")
						T("abcdefghij")
						T("klmnopqrst")
						T("uvwxyz###.");
		std::size_t n;

		n = text.find_first_of(T('0'));				UNITST_EQ( n, 0 );
		n = text.find_first_of(T('a'));				UNITST_EQ( n, 10 );
		n = text.find_first_of(T('.'));				UNITST_EQ( n, 39 );
		n = text.find_first_of(T('\0'));			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('?'));				UNITST_EQ( n, text.npos );

		n = text.find_first_of(T('0'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('a'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_of(T('.'),10);			UNITST_EQ( n, 39 );
		n = text.find_first_of(T('\0'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('?'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('0'),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(T('0'),100);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('a'),100);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('.'),100);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('\0'),100);		UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('?'),100);			UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0"));				UNITST_EQ( n, 0 );
		n = text.find_first_of(T("a"));				UNITST_EQ( n, 10 );
		n = text.find_first_of(T("."));				UNITST_EQ( n, 39 );
		n = text.find_first_of(T("?"));				UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0"),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("a"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_of(T("."),10);			UNITST_EQ( n, 39 );
		n = text.find_first_of(T("?"),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("0"),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0"),100);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("a"),100);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("."),100);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("?"),100);			UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0123456789"));	UNITST_EQ( n, 0 );
		n = text.find_first_of(T("badcfe"));		UNITST_EQ( n, 10 );
		n = text.find_first_of(T(".#"));			UNITST_EQ( n, 36 );

		n = text.find_first_of(T("0123456789"),5);	UNITST_EQ( n, 5 );
		n = text.find_first_of(T("badcfe"), 5);		UNITST_EQ( n, 10 );
		n = text.find_first_of(T("0123456789"),10);	UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("badcfe"), 10);	UNITST_EQ( n, 10 );
		n = text.find_first_of(T(".#"), 10);		UNITST_EQ( n, 36 );
		n = text.find_first_of(T("a0"),text.npos);	UNITST_EQ( n, text.npos );


		n = text.find_first_of(STRING(T("0")));			UNITST_EQ( n, 0 );
		n = text.find_first_of(STRING(T("a")));			UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".")));			UNITST_EQ( n, 39 );
		n = text.find_first_of(STRING(T("?")));			UNITST_EQ( n, text.npos );

		n = text.find_first_of(STRING(T("0")),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("a")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".")),10);			UNITST_EQ( n, 39 );
		n = text.find_first_of(STRING(T("?")),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("0")),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(STRING(T("0123456789")));	UNITST_EQ( n, 0 );
		n = text.find_first_of(STRING(T("badcfe")));		UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".#")));			UNITST_EQ( n, 36 );

		n = text.find_first_of(STRING(T("0123456789")),5);	UNITST_EQ( n, 5 );
		n = text.find_first_of(STRING(T("badcfe")), 5);		UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T("0123456789")),10);	UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("badcfe")), 10);	UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".#")), 10);		UNITST_EQ( n, 36 );
		n = text.find_first_of(STRING(T("a0")),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("")),text.npos);	UNITST_EQ( n, text.npos );


		n = text.find_first_of(T("\0"));					UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("\0"),10);					UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("\0"),100);				UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("")));				UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("")), 10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("\0")));			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("\0")),10);			UNITST_EQ( n, text.npos );


		text += STRING(text);

		n = text.find_first_of(T('0'));				UNITST_EQ( n, 0 );
		n = text.find_first_of(T('a'));				UNITST_EQ( n, 10 );
		n = text.find_first_of(T('.'));				UNITST_EQ( n, 39 );
		n = text.find_first_of(T('\0'));			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('?'));				UNITST_EQ( n, text.npos );

		n = text.find_first_of(T('0'),10);			UNITST_EQ( n, 40 );
		n = text.find_first_of(T('a'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_of(T('.'),10);			UNITST_EQ( n, 39 );
		n = text.find_first_of(T('\0'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('?'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('0'),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0"));				UNITST_EQ( n, 0 );
		n = text.find_first_of(T("a"));				UNITST_EQ( n, 10 );
		n = text.find_first_of(T("."));				UNITST_EQ( n, 39 );
		n = text.find_first_of(T("\0"));			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("?"));				UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0"),10);			UNITST_EQ( n, 40 );
		n = text.find_first_of(T("a"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_of(T("."),10);			UNITST_EQ( n, 39 );
		n = text.find_first_of(T("\0"),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("?"),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("0"),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(T("0123456789"));	UNITST_EQ( n, 0 );
		n = text.find_first_of(T("badcfe"));		UNITST_EQ( n, 10 );
		n = text.find_first_of(T(".#"));			UNITST_EQ( n, 36 );

		n = text.find_first_of(T("0123456789"),5);	UNITST_EQ( n, 5 );
		n = text.find_first_of(T("badcfe"), 5);		UNITST_EQ( n, 10 );
		n = text.find_first_of(T("0123456789"),10);	UNITST_EQ( n, 40 );
		n = text.find_first_of(T("badcfe"), 10);	UNITST_EQ( n, 10 );
		n = text.find_first_of(T(".#"), 10);		UNITST_EQ( n, 36 );
		n = text.find_first_of(T("a0"),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(STRING(T("0")));			UNITST_EQ( n, 0 );
		n = text.find_first_of(STRING(T("a")));			UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".")));			UNITST_EQ( n, 39 );
		n = text.find_first_of(STRING(T("\0")));		UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("?")));			UNITST_EQ( n, text.npos );

		n = text.find_first_of(STRING(T("0")),10);			UNITST_EQ( n, 40 );
		n = text.find_first_of(STRING(T("a")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".")),10);			UNITST_EQ( n, 39 );
		n = text.find_first_of(STRING(T("\0")),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("?")),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("0")),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_of(STRING(T("0123456789")));	UNITST_EQ( n, 0 );
		n = text.find_first_of(STRING(T("badcfe")));		UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".#")));			UNITST_EQ( n, 36 );

		n = text.find_first_of(STRING(T("0123456789")),5);	UNITST_EQ( n, 5 );
		n = text.find_first_of(STRING(T("badcfe")), 5);		UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T("0123456789")),10);	UNITST_EQ( n, 40 );
		n = text.find_first_of(STRING(T("badcfe")), 10);	UNITST_EQ( n, 10 );
		n = text.find_first_of(STRING(T(".#")), 10);		UNITST_EQ( n, 36 );
		n = text.find_first_of(STRING(T("a0")),text.npos);	UNITST_EQ( n, text.npos );
	}

	void test_find_last_of()
	{
		STRING	text =	T("0123456789")
						T("abcdefghij")
						T("klmnopqrst")
						T("uvwxyz###.");
		std::size_t n;

		n = text.find_last_of(T('0'));				UNITST_EQ( n, 0 );
		n = text.find_last_of(T('a'));				UNITST_EQ( n, 10 );
		n = text.find_last_of(T('.'));				UNITST_EQ( n, 39 );
		n = text.find_last_of(T('\0'));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(T('?'));				UNITST_EQ( n, text.npos );

		n = text.find_last_of(T('0'),10);			UNITST_EQ( n, 0 );
		n = text.find_last_of(T('a'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_of(T('.'),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T('\0'),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T('?'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('0'),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(T("0"));				UNITST_EQ( n, 0 );
		n = text.find_last_of(T("a"));				UNITST_EQ( n, 10);
		n = text.find_last_of(T("."));				UNITST_EQ( n, 39);
		n = text.find_last_of(T("\0"));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(T("?"));				UNITST_EQ( n, text.npos );

		n = text.find_last_of(T("0"),10);			UNITST_EQ( n, 0 );
		n = text.find_last_of(T("a"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_of(T("."),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T("\0"),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T("?"),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("0"),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(T("0123456789"));		UNITST_EQ( n, 9  );
		n = text.find_last_of(T("badcfe"));			UNITST_EQ( n, 15 );
		n = text.find_last_of(T(".#"));				UNITST_EQ( n, 39 );

		n = text.find_last_of(T("0123456789"),5);	UNITST_EQ( n, 5 );
		n = text.find_last_of(T("badcfe"), 5);		UNITST_EQ( n, text.npos);
		n = text.find_last_of(T("0123456789"), 9);	UNITST_EQ( n, 9 );
		n = text.find_last_of(T("badcfe"), 9);		UNITST_EQ( n, text.npos );
		n = text.find_last_of(T(".#"), 38 );		UNITST_EQ( n, 38 );
		n = text.find_first_of(T("a0"),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(STRING(T("0")));				UNITST_EQ( n, 0 );
		n = text.find_last_of(STRING(T("a")));				UNITST_EQ( n, 10);
		n = text.find_last_of(STRING(T(".")));				UNITST_EQ( n, 39);
		n = text.find_last_of(STRING(T("\0")));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("?")));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("")));				UNITST_EQ( n, text.npos );

		n = text.find_last_of(STRING(T("0")),10);			UNITST_EQ( n, 0 );
		n = text.find_last_of(STRING(T("a")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_of(STRING(T(".")),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("\0")),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("?")),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("")),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("0")),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(STRING(T("0123456789")));		UNITST_EQ( n, 9  );
		n = text.find_last_of(STRING(T("badcfe")));			UNITST_EQ( n, 15 );
		n = text.find_last_of(STRING(T(".#")));				UNITST_EQ( n, 39 );

		n = text.find_last_of(STRING(T("0123456789")),5);	UNITST_EQ( n, 5 );
		n = text.find_last_of(STRING(T("badcfe")), 5);		UNITST_EQ( n, text.npos);
		n = text.find_last_of(STRING(T("0123456789")), 9);	UNITST_EQ( n, 9 );
		n = text.find_last_of(STRING(T("badcfe")), 9);		UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T(".#")), 38 );		UNITST_EQ( n, 38 );
		n = text.find_first_of(STRING(T("a0")),0);			UNITST_EQ( n, 0 );

		text += STRING(text);

		n = text.find_last_of(T('0'));				UNITST_EQ( n, 40 );
		n = text.find_last_of(T('a'));				UNITST_EQ( n, 50 );
		n = text.find_last_of(T('.'));				UNITST_EQ( n, 79 );
		n = text.find_last_of(T('\0'));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(T('?'));				UNITST_EQ( n, text.npos );

		n = text.find_last_of(T('0'),10);			UNITST_EQ( n, 0 );
		n = text.find_last_of(T('a'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_of(T('.'),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T('\0'),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T('?'),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T('0'),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(T("0"));				UNITST_EQ( n, 40);
		n = text.find_last_of(T("a"));				UNITST_EQ( n, 50);
		n = text.find_last_of(T("."));				UNITST_EQ( n, 79);
		n = text.find_last_of(T("\0"));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(T("?"));				UNITST_EQ( n, text.npos );

		n = text.find_last_of(T("0"),10);			UNITST_EQ( n, 0 );
		n = text.find_last_of(T("a"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_of(T("."),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T("\0"),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(T("?"),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(T("0"),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(T("0123456789"));		UNITST_EQ( n, 49 );
		n = text.find_last_of(T("badcfe"));			UNITST_EQ( n, 55 );
		n = text.find_last_of(T(".#"));				UNITST_EQ( n, 79 );

		n = text.find_last_of(T("0123456789"),5);	UNITST_EQ( n, 5 );
		n = text.find_last_of(T("badcfe"), 5);		UNITST_EQ( n, text.npos);
		n = text.find_last_of(T("0123456789"), 9);	UNITST_EQ( n, 9 );
		n = text.find_last_of(T("badcfe"), 9);		UNITST_EQ( n, text.npos );
		n = text.find_last_of(T(".#"), 38 );		UNITST_EQ( n, 38 );
		n = text.find_first_of(T("a0"),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(STRING(T("0")));				UNITST_EQ( n, 40);
		n = text.find_last_of(STRING(T("a")));				UNITST_EQ( n, 50);
		n = text.find_last_of(STRING(T(".")));				UNITST_EQ( n, 79);
		n = text.find_last_of(STRING(T("\0")));				UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("?")));				UNITST_EQ( n, text.npos );

		n = text.find_last_of(STRING(T("0")),10);			UNITST_EQ( n, 0 );
		n = text.find_last_of(STRING(T("a")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_of(STRING(T(".")),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("\0")),10);			UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T("?")),10);			UNITST_EQ( n, text.npos );
		n = text.find_first_of(STRING(T("0")),0);			UNITST_EQ( n, 0 );

		n = text.find_last_of(STRING(T("0123456789")));		UNITST_EQ( n, 49 );
		n = text.find_last_of(STRING(T("badcfe")));			UNITST_EQ( n, 55 );
		n = text.find_last_of(STRING(T(".#")));				UNITST_EQ( n, 79 );

		n = text.find_last_of(STRING(T("0123456789")),5);	UNITST_EQ( n, 5 );
		n = text.find_last_of(STRING(T("badcfe")), 5);		UNITST_EQ( n, text.npos);
		n = text.find_last_of(STRING(T("0123456789")), 9);	UNITST_EQ( n, 9 );
		n = text.find_last_of(STRING(T("badcfe")), 9);		UNITST_EQ( n, text.npos );
		n = text.find_last_of(STRING(T(".#")), 38 );		UNITST_EQ( n, 38 );
		n = text.find_first_of(STRING(T("a0")),0);			UNITST_EQ( n, 0 );
	}


	void test_find_first_not_of()
	{
		STRING	text =	T("0123456789")
						T("abcdefghij")
						T("klmnopqrst")
						T("uvwxyz###.");
		std::size_t n;

		n = text.find_first_not_of(T('0'));			UNITST_EQ( n, 1  );
		n = text.find_first_not_of(T('a'));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T('.'));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T('\0'));		UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T('?'));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(T('0'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('a'),10);			UNITST_EQ( n, 11 );
		n = text.find_first_not_of(T('.'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('\0'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('?'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('0'),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_not_of(T("0"));				UNITST_EQ( n, 1  );
		n = text.find_first_not_of(T("a"));				UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T("."));				UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T("?"));				UNITST_EQ( n, 0  );
		//n = text.find_first_not_of(T("\0"));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T(""));				UNITST_EQ( n, 0  );

		n = text.find_first_not_of(T("0"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("a"),10);			UNITST_EQ( n, 11 );
		n = text.find_first_not_of(T("."),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("\0"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("?"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("0"),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(T(""), 10);			UNITST_EQ( n, 10 );

		n = text.find_first_not_of(T("0123456789"));	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("badcfe"));		UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T(".#"));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(T("0123456789"),5);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("badcfe"), 5);		UNITST_EQ( n, 5  );
		n = text.find_first_not_of(T("0123456789"),10);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("badcfe"), 10);	UNITST_EQ( n, 16 );
		n = text.find_first_not_of(T(".#"), 10);		UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("a0"),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(T(""),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_not_of(STRING(T("0")));			UNITST_EQ( n, 1  );
		n = text.find_first_not_of(STRING(T("a")));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T(".")));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T("?")));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T("")));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(STRING(T("0")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("a")),10);			UNITST_EQ( n, 11 );
		n = text.find_first_not_of(STRING(T(".")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("\0")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("?")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("0")),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(STRING(T("")), 10);			UNITST_EQ( n, 10 );

		n = text.find_first_not_of(STRING(T("0123456789")));	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("badcfe")));		UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T(".#")));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(STRING(T("0123456789")),5);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("badcfe")), 5);		UNITST_EQ( n, 5  );
		n = text.find_first_not_of(STRING(T("0123456789")),10);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("badcfe")), 10);	UNITST_EQ( n, 16 );
		n = text.find_first_not_of(STRING(T(".#")), 10);		UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("a0")),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(STRING(T("")),text.npos);	UNITST_EQ( n, text.npos );

		text += STRING(text);

		n = text.find_first_not_of(T('0'));			UNITST_EQ( n, 1  );
		n = text.find_first_not_of(T('a'));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T('.'));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T('\0'));		UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T('?'));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(T('0'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('a'),10);			UNITST_EQ( n, 11 );
		n = text.find_first_not_of(T('.'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('\0'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('?'),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T('0'),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_not_of(T("0"));				UNITST_EQ( n, 1  );
		n = text.find_first_not_of(T("a"));				UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T("."));				UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T("?"));				UNITST_EQ( n, 0  );
		//n = text.find_first_not_of(T("\0"));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T(""));				UNITST_EQ( n, 0  );

		n = text.find_first_not_of(T("0"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("a"),10);			UNITST_EQ( n, 11 );
		n = text.find_first_not_of(T("."),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("\0"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("?"),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("0"),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(T(""), 10);			UNITST_EQ( n, 10 );

		n = text.find_first_not_of(T("0123456789"));	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("badcfe"));		UNITST_EQ( n, 0  );
		n = text.find_first_not_of(T(".#"));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(T("0123456789"),5);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("badcfe"), 5);		UNITST_EQ( n, 5  );
		n = text.find_first_not_of(T("0123456789"),10);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("badcfe"), 10);	UNITST_EQ( n, 16 );
		n = text.find_first_not_of(T(".#"), 10);		UNITST_EQ( n, 10 );
		n = text.find_first_not_of(T("a0"),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(T(""),text.npos);	UNITST_EQ( n, text.npos );

		n = text.find_first_not_of(STRING(T("0")));			UNITST_EQ( n, 1  );
		n = text.find_first_not_of(STRING(T("a")));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T(".")));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T("?")));			UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T("")));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(STRING(T("0")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("a")),10);			UNITST_EQ( n, 11 );
		n = text.find_first_not_of(STRING(T(".")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("\0")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("?")),10);			UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("0")),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(STRING(T("")), 10);			UNITST_EQ( n, 10 );

		n = text.find_first_not_of(STRING(T("0123456789")));	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("badcfe")));		UNITST_EQ( n, 0  );
		n = text.find_first_not_of(STRING(T(".#")));			UNITST_EQ( n, 0  );

		n = text.find_first_not_of(STRING(T("0123456789")),5);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("badcfe")), 5);		UNITST_EQ( n, 5  );
		n = text.find_first_not_of(STRING(T("0123456789")),10);	UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("badcfe")), 10);	UNITST_EQ( n, 16 );
		n = text.find_first_not_of(STRING(T(".#")), 10);		UNITST_EQ( n, 10 );
		n = text.find_first_not_of(STRING(T("a0")),text.npos);	UNITST_EQ( n, text.npos );
		n = text.find_first_not_of(STRING(T("")),text.npos);	UNITST_EQ( n, text.npos );
	}

	void test_find_last_not_of()
	{
		STRING	text =	T("0123456789")
						T("abcdefghij")
						T("klmnopqrst")
						T("uvwxyz###.");
		std::size_t n;

		n = text.find_last_not_of(T('0'));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T('a'));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T('.'));				UNITST_EQ( n, 38 );
		n = text.find_last_not_of(T('\0'));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T('?'));				UNITST_EQ( n, 39 );

		n = text.find_last_not_of(T('0'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('a'),10);			UNITST_EQ( n,	9 );
		n = text.find_last_not_of(T('.'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('\0'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('?'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('0'),text.npos);	UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T('0'),0);			UNITST_EQ( n, text.npos );

		n = text.find_last_not_of(T("0"));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T("a"));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T("."));				UNITST_EQ( n, 38 );
		n = text.find_last_not_of(T("?"));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T(""));				UNITST_EQ( n, 39 );

		n = text.find_last_not_of(T("0"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("a"),10);			UNITST_EQ( n,	9 );
		n = text.find_last_not_of(T("."),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("\0"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("?"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("0"),text.npos);	UNITST_EQ( n, 39 );

		n = text.find_last_not_of(T("0123456789"));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T("badcfe"));					UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T(".#"));						UNITST_EQ( n, 35 );

		n = text.find_last_not_of(T("0123456789"),5);			UNITST_EQ( n, text.npos );
		n = text.find_last_not_of(T("badcfe"), 5);				UNITST_EQ( n,	5 );
		n = text.find_last_not_of(T("0123456789"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("badcfe"), 10);				UNITST_EQ( n,	9 );
		n = text.find_last_not_of(T(".#"), 10);					UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("a0"),text.npos);			UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T(""),text.npos);				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(T(""),0);						UNITST_EQ( n,	0 );

		n = text.find_last_not_of(STRING(T("0")));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T("a")));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T(".")));				UNITST_EQ( n, 38 );
		n = text.find_last_not_of(STRING(T("?")));				UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T("")));				UNITST_EQ( n, 39 );

		n = text.find_last_not_of(STRING(T("0")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("a")),10);			UNITST_EQ( n,	9 );
		n = text.find_last_not_of(STRING(T(".")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("\0")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("?")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("0")),text.npos);	UNITST_EQ( n, 39 );

		n = text.find_last_not_of(STRING(T("0123456789")));		UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T("badcfe")));			UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T(".#")));				UNITST_EQ( n, 35 );

		n = text.find_last_not_of(STRING(T("0123456789")),5);	UNITST_EQ( n, text.npos );
		n = text.find_last_not_of(STRING(T("badcfe")), 5);		UNITST_EQ( n,	5 );
		n = text.find_last_not_of(STRING(T("0123456789")),10);	UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("badcfe")), 10);		UNITST_EQ( n,	9 );
		n = text.find_last_not_of(STRING(T(".#")), 10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("a0")),text.npos);	UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T("")),text.npos);		UNITST_EQ( n, 39 );
		n = text.find_last_not_of(STRING(T("")),0);				UNITST_EQ( n,	0 );

		text += STRING(text);

		n = text.find_last_not_of(T('0'));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T('a'));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T('.'));				UNITST_EQ( n, 78 );
		n = text.find_last_not_of(T('\0'));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T('?'));				UNITST_EQ( n, 79 );

		n = text.find_last_not_of(T('0'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('a'),10);			UNITST_EQ( n,	9 );
		n = text.find_last_not_of(T('.'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('\0'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('?'),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T('0'),text.npos);	UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T('0'),0);			UNITST_EQ( n, text.npos );

		n = text.find_last_not_of(T("0"));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T("a"));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T("."));				UNITST_EQ( n, 78 );
		n = text.find_last_not_of(T("?"));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T(""));				UNITST_EQ( n, 79 );

		n = text.find_last_not_of(T("0"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("a"),10);			UNITST_EQ( n,	9 );
		n = text.find_last_not_of(T("."),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("\0"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("?"),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("0"),text.npos);	UNITST_EQ( n, 79 );

		n = text.find_last_not_of(T("0123456789"));		UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T("badcfe"));			UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T(".#"));				UNITST_EQ( n, 75 );

		n = text.find_last_not_of(T("0123456789"),5);	UNITST_EQ( n, text.npos );
		n = text.find_last_not_of(T("badcfe"), 5);		UNITST_EQ( n,	5 );
		n = text.find_last_not_of(T("0123456789"),10);	UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("badcfe"), 10);		UNITST_EQ( n,	9 );
		n = text.find_last_not_of(T(".#"), 10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(T("a0"),text.npos);	UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T(""),text.npos);		UNITST_EQ( n, 79 );
		n = text.find_last_not_of(T(""),0);				UNITST_EQ( n,	0 );

		n = text.find_last_not_of(STRING(T("0")));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T("a")));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T(".")));				UNITST_EQ( n, 78 );
		n = text.find_last_not_of(STRING(T("?")));				UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T("")));				UNITST_EQ( n, 79 );

		n = text.find_last_not_of(STRING(T("0")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("a")),10);			UNITST_EQ( n,	9 );
		n = text.find_last_not_of(STRING(T(".")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("\0")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("?")),10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("0")),text.npos);	UNITST_EQ( n, 79 );

		n = text.find_last_not_of(STRING(T("0123456789")));		UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T("badcfe")));			UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T(".#")));				UNITST_EQ( n, 75 );

		n = text.find_last_not_of(STRING(T("0123456789")),5);	UNITST_EQ( n, text.npos );
		n = text.find_last_not_of(STRING(T("badcfe")), 5);		UNITST_EQ( n,	5 );
		n = text.find_last_not_of(STRING(T("0123456789")),10);	UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("badcfe")), 10);		UNITST_EQ( n,	9 );
		n = text.find_last_not_of(STRING(T(".#")), 10);			UNITST_EQ( n, 10 );
		n = text.find_last_not_of(STRING(T("a0")),text.npos);	UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T("")),text.npos);		UNITST_EQ( n, 79 );
		n = text.find_last_not_of(STRING(T("")),0);				UNITST_EQ( n,	0 );
	}
};



#if !(defined __WATCOMC__) && !(defined __GNUC__) && !(defined __BORLANDC__)
UNITST_TEST(std_string_test) {
  #ifdef UNICODE
	String_Test<std::wstring>	string_test;
  #else
	String_Test<std::string>	string_test;
  #endif
	string_test.test();
}
#endif


UNITST_TEST(ya_string_test) {
  #ifdef UNICODE
	String_Test<ya_wstring>	string_test;
  #else
	String_Test<ya_string>	string_test;
  #endif
	string_test.test();
}
